import { messageTypes } from '../../../misc';
import { ResourceManager } from '../../database/ResourceManager';
import { RAFirebaseOptions } from '../../options';
import { FiReLogger } from '../../../tools/reads-logger';
export declare class FirebaseLazyLoadingClient {
    private readonly options;
    private readonly rm;
    private readsLogger;
    constructor(options: RAFirebaseOptions, rm: ResourceManager, readsLogger: FiReLogger | false);
    setReadsLogger(readsLogger: FiReLogger | false): void;
    apiGetList(resourceName: string, reactAdminParams: messageTypes.IParamsGetList): Promise<messageTypes.IResponseGetList>;
    apiGetManyReference(resourceName: string, reactAdminParams: messageTypes.IParamsGetManyReference): Promise<messageTypes.IResponseGetManyReference>;
    private paramsToQuery;
    private filtersToQuery;
    private sortToQuery;
    private paginationToQuery;
    private getFullParamsForQuery;
    private getNextPageParams;
    private checkIfOnLastPage;
    private setQueryCursor;
    private getQueryCursor;
    clearQueryCursors(resourceName: string): void;
    private findLastQueryCursor;
    private tryGetResource;
    incrementFirebaseReadsCounter(newReads: number): void;
}
