import { RAFirebaseOptions } from '../options';
import { IFirebaseWrapper } from './firebase/IFirebaseWrapper';
import { IFirebaseClient } from './IFirebaseClient';
import { messageTypes } from '../../misc';
export declare class FirebaseClient implements IFirebaseClient {
    private readonly fireWrapper;
    readonly options: RAFirebaseOptions;
    private readonly db;
    private readonly rm;
    private readonly lazyLoadingClient;
    private readsLogger;
    constructor(fireWrapper: IFirebaseWrapper, options: RAFirebaseOptions);
    private getLoggerAsync;
    apiGetList(resourceName: string, params: messageTypes.IParamsGetList): Promise<messageTypes.IResponseGetList>;
    apiGetOne(resourceName: string, params: messageTypes.IParamsGetOne): Promise<messageTypes.IResponseGetOne>;
    apiCreate(resourceName: string, params: messageTypes.IParamsCreate): Promise<messageTypes.IResponseCreate>;
    apiUpdate(resourceName: string, params: messageTypes.IParamsUpdate): Promise<messageTypes.IResponseUpdate>;
    apiUpdateMany(resourceName: string, params: messageTypes.IParamsUpdateMany): Promise<messageTypes.IResponseUpdateMany>;
    apiSoftDelete(resourceName: string, params: messageTypes.IParamsUpdate): Promise<messageTypes.IResponseUpdate>;
    apiSoftDeleteMany(resourceName: string, params: messageTypes.IParamsUpdateMany): Promise<messageTypes.IResponseUpdateMany>;
    apiDelete(resourceName: string, params: messageTypes.IParamsDelete): Promise<messageTypes.IResponseDelete>;
    apiDeleteMany(resourceName: string, params: messageTypes.IParamsDeleteMany): Promise<messageTypes.IResponseDeleteMany>;
    apiGetMany(resourceName: string, params: messageTypes.IParamsGetMany): Promise<messageTypes.IResponseGetMany>;
    apiGetManyReference(resourceName: string, params: messageTypes.IParamsGetManyReference): Promise<messageTypes.IResponseGetManyReference>;
    private tryGetResource;
    private getCurrentUserEmail;
    private getCurrentUserId;
    private parseDataAndUpload;
    private checkRemoveIdField;
    private addCreatedByFields;
    private addUpdatedByFields;
    private uploadAndGetLink;
    private saveFile;
    private clearQueryCursors;
    private incrementFirebaseReadsCounter;
}
