import { CollectionReference } from '@firebase/firestore-types';
import { RAFirebaseOptions } from '../options';
import { IFirebaseWrapper } from './firebase/IFirebaseWrapper';
import { User } from '@firebase/auth-types';
import { messageTypes } from '../../misc';
export interface IResource {
    path: string;
    pathAbsolute: string;
    collection: CollectionReference;
    list: Array<{}>;
}
export declare class ResourceManager {
    private fireWrapper;
    private options;
    private resources;
    private db;
    constructor(fireWrapper: IFirebaseWrapper, options: RAFirebaseOptions);
    GetResource(relativePath: string): IResource;
    TryGetResourcePromise(relativePath: string, collectionQuery: messageTypes.CollectionQueryType): Promise<IResource>;
    RefreshResource(relativePath: string, collectionQuery: messageTypes.CollectionQueryType): Promise<void>;
    GetSingleDoc(relativePath: string, docId: string): Promise<{
        id: string;
    }>;
    private initPath;
    getUserLogin(): Promise<User>;
    private removeResource;
    private applyQuery;
}
