import { RAFirebaseOptions } from '../../../providers/options';
import 'firebase/auth';
declare type ReadsKey = 'customReads' | 'sessionReads';
declare type GetReadsFn = (readsKey: keyof FiReLoggerStorageKeys) => number;
declare type ResetReadsFn = (readsKey: ReadsKey) => void;
declare type IncrementReadsFn = (newReads: number, readsKey: ReadsKey) => void;
interface FiReLoggerStorageKeys {
    customReads: string;
    lastCustomReads: string;
    sessionReads: string;
    lastSessionReads: string;
}
export default class ReadsLoggerLocalStorageUtils {
    private readonly options;
    private storageKeys;
    private get hasKeys();
    private readonly loggerOptions;
    private readonly DEFAULT_PREFIX;
    private isInitialized;
    private currentUserId;
    private emitSessionReadsStreams;
    private authStateUnsubscribe;
    get keys(): FiReLoggerStorageKeys;
    getReads: GetReadsFn;
    resetReads: ResetReadsFn;
    incrementReads: IncrementReadsFn;
    init(sessionStreamEmitCallback: () => void): Promise<boolean>;
    clean: () => void;
    constructor(options: RAFirebaseOptions);
    private startUserSubscription;
    private resetSessionReads;
    private setReadsInStorage;
    private getLocalStorageKeys;
    private checkErrors;
    private checkKeysError;
    private checkInitError;
}
export {};
